import { Controller } from "ada-cloud-util/boost";
import { controller, action, service } from "ada-cloud-util/boost/annotation";
import Result from "ada-cloud-util/result";
import {{ upperTableCamelName }}Service from "./../service/{{ tableName }}";
import {{ upperTableCamelName }}Model from "./../model/{{ tableName }}";

@controller({ path: "/{{ url }}" })
class {{ upperTableCamelName }}Controller extends Controller {

    @service({{ upperTableCamelName }}Service)
    {{ tableCamelName }}Service = null;

    @action({ path: "/list" })
    get{{ upperTableCamelName }}ListSimple({ request }) {
        return this.{{ tableCamelName }}Service.get{{ upperTableCamelName }}List({ entity: request.query }).then(list => Result.getSuccessResult(list));
    }

    @action({ path: "/list", method: "post" })
    get{{ upperTableCamelName }}List({ request }) {
        let { entity, query } = request.body;
        return this.{{ tableCamelName }}Service.get{{ upperTableCamelName }}List({ entity, query }).then(list => Result.getSuccessResult(list));
    }

    @action({ path: "/detail" })
    get{{ upperTableCamelName }}Detail({ request }) {
        return this.{{ tableCamelName }}Service.get{{ upperTableCamelName }}Detail(request.query).then(model => Result.getSuccessResult(model));
    }

    @action({ 
        path: "/add", 
        method: "post" 
    })
    add{{ upperTableCamelName }}({ request }) {
        let model = new {{ upperTableCamelName }}Model().set(request.body), { result, message } = model.check();
        if (result) {
            return this.{{ tableCamelName }}Service.add{{ upperTableCamelName }}(model).then(model => Result.getSuccessResult(model));
        } else {
            return this.getErrorResult(message);
        }
    }

    @action({ 
        path: "/edit", 
        method: "post" 
    })
    edit{{ upperTableCamelName }}({ request }) {
        let model = new {{ upperTableCamelName }}Model().set(request.body), { result, message } = model.check();
        if (result) {
            return this.{{ tableCamelName }}Service.edit{{ upperTableCamelName }}(model).then(model => Result.getSuccessResult(model));
        } else {
            return this.getErrorResult(message);
        }
    }

    @action({ 
        path: "/remove", 
        method: "post" 
    })
    remove{{ upperTableCamelName }}({ request }) {
        let model = new {{ upperTableCamelName }}Model().set(request.body), { result, message } = model.check();
        if (result) {
            return this.{{ tableCamelName }}Service.remove{{ upperTableCamelName }}(model).then(model => Result.getSuccessResult(model));
        } else {
            return this.getErrorResult(message);
        }
    }
}

export default {{ upperTableCamelName }}Controller;